com.amazonaws.services.elastictranscoder.model

## Class Pipeline

- java.lang.Object
- - com.amazonaws.services.elastictranscoder.model.Pipeline

All Implemented Interfaces:
  Serializable, Cloneable

    public class Pipeline
    extends Object
    implements Serializable, Cloneable

The pipeline (queue) that is used to manage jobs.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`Pipeline()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Pipeline` `clone()`
`boolean` `equals(Object obj)`
`String` `getArn()` The Amazon Resource Name (ARN) for the pipeline.
`String` `getAwsKmsKeyArn()` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.
`PipelineOutputConfig` `getContentConfig()` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.
`String` `getId()` The identifier for the pipeline.
`String` `getInputBucket()` The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.
`String` `getName()` The name of the pipeline.
`Notifications` `getNotifications()` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`String` `getOutputBucket()` The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists.
`String` `getRole()` The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.
`String` `getStatus()` The current status of the pipeline:
`PipelineOutputConfig` `getThumbnailConfig()` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.
`int` `hashCode()`
`void` `setArn(String arn)` The Amazon Resource Name (ARN) for the pipeline.
`void` `setAwsKmsKeyArn(String awsKmsKeyArn)` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.
`void` `setContentConfig(PipelineOutputConfig contentConfig)` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.
`void` `setId(String id)` The identifier for the pipeline.
`void` `setInputBucket(String inputBucket)` The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.
`void` `setName(String name)` The name of the pipeline.
`void` `setNotifications(Notifications notifications)` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`void` `setOutputBucket(String outputBucket)` The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists.
`void` `setRole(String role)` The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.
`void` `setStatus(String status)` The current status of the pipeline:
`void` `setThumbnailConfig(PipelineOutputConfig thumbnailConfig)` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`Pipeline` `withArn(String arn)` The Amazon Resource Name (ARN) for the pipeline.
`Pipeline` `withAwsKmsKeyArn(String awsKmsKeyArn)` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.
`Pipeline` `withContentConfig(PipelineOutputConfig contentConfig)` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.
`Pipeline` `withId(String id)` The identifier for the pipeline.
`Pipeline` `withInputBucket(String inputBucket)` The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.
`Pipeline` `withName(String name)` The name of the pipeline.
`Pipeline` `withNotifications(Notifications notifications)` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`Pipeline` `withOutputBucket(String outputBucket)` The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists.
`Pipeline` `withRole(String role)` The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.
`Pipeline` `withStatus(String status)` The current status of the pipeline:
`Pipeline` `withThumbnailConfig(PipelineOutputConfig thumbnailConfig)` Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Pipeline

    public Pipeline()

### Method Detail

#### setId

    public void setId(String id)

The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.

Parameters:
  `id` - The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.

#### getId

    public String getId()

The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.

Returns:
  The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.

#### withId

    public Pipeline withId(String id)

The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.

Parameters:
  `id` - The identifier for the pipeline. You use this value to identify the pipeline in which you want to perform a variety of operations, such as creating a job or a preset.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setArn

    public void setArn(String arn)

The Amazon Resource Name (ARN) for the pipeline.

Parameters:
  `arn` - The Amazon Resource Name (ARN) for the pipeline.

#### getArn

    public String getArn()

The Amazon Resource Name (ARN) for the pipeline.

Returns:
  The Amazon Resource Name (ARN) for the pipeline.

#### withArn

    public Pipeline withArn(String arn)

The Amazon Resource Name (ARN) for the pipeline.

Parameters:
  `arn` - The Amazon Resource Name (ARN) for the pipeline.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setName

    public void setName(String name)

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters

Parameters:
  `name` - The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters

#### getName

    public String getName()

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters

Returns:
  The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters

#### withName

    public Pipeline withName(String name)

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters

Parameters:
  `name` - The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setStatus

    public void setStatus(String status)

The current status of the pipeline:

- `Active`: The pipeline is processing jobs.

- `Paused`: The pipeline is not currently processing jobs.

Parameters:
  `status` - The current status of the pipeline:

  - `Active`: The pipeline is processing jobs.

  - `Paused`: The pipeline is not currently processing jobs.

#### getStatus

    public String getStatus()

The current status of the pipeline:

- `Active`: The pipeline is processing jobs.

- `Paused`: The pipeline is not currently processing jobs.

Returns:
  The current status of the pipeline:

  - `Active`: The pipeline is processing jobs.

  - `Paused`: The pipeline is not currently processing jobs.

#### withStatus

    public Pipeline withStatus(String status)

The current status of the pipeline:

- `Active`: The pipeline is processing jobs.

- `Paused`: The pipeline is not currently processing jobs.

Parameters:
  `status` - The current status of the pipeline:

  - `Active`: The pipeline is processing jobs.

  - `Paused`: The pipeline is not currently processing jobs.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setInputBucket

    public void setInputBucket(String inputBucket)

The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.

Parameters:
  `inputBucket` - The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.

#### getInputBucket

    public String getInputBucket()

The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.

Returns:
  The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.

#### withInputBucket

    public Pipeline withInputBucket(String inputBucket)

The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.

Parameters:
  `inputBucket` - The Amazon S3 bucket from which Elastic Transcoder gets media files for transcoding and the graphics files, if any, that you want to use for watermarks.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setOutputBucket

    public void setOutputBucket(String outputBucket)

The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.

Parameters:
  `outputBucket` - The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.

#### getOutputBucket

    public String getOutputBucket()

The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.

Returns:
  The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.

#### withOutputBucket

    public Pipeline withOutputBucket(String outputBucket)

The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.

Parameters:
  `outputBucket` - The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files, thumbnails, and playlists. Either you specify this value, or you specify both `ContentConfig` and `ThumbnailConfig`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setRole

    public void setRole(String role)

The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.

Parameters:
  `role` - The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.

#### getRole

    public String getRole()

The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.

Returns:
  The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.

#### withRole

    public Pipeline withRole(String role)

The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.

Parameters:
  `role` - The IAM Amazon Resource Name (ARN) for the role that Elastic Transcoder uses to transcode jobs for this pipeline.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setAwsKmsKeyArn

    public void setAwsKmsKeyArn(String awsKmsKeyArn)

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Parameters:
  `awsKmsKeyArn` - The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

#### getAwsKmsKeyArn

    public String getAwsKmsKeyArn()

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Returns:
  The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

#### withAwsKmsKeyArn

    public Pipeline withAwsKmsKeyArn(String awsKmsKeyArn)

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Parameters:
  `awsKmsKeyArn` - The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setNotifications

    public void setNotifications(Notifications notifications)

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

- Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

- Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

- Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

Parameters:
  `notifications` - The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

  - Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

  - Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

  - Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

#### getNotifications

    public Notifications getNotifications()

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

- Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

- Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

- Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

Returns:
  The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

  - Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

  - Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

  - Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

#### withNotifications

    public Pipeline withNotifications(Notifications notifications)

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

- Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

- Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

- Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

Parameters:
  `notifications` - The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing (optional): The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process the job.

  - Completed (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing the job.

  - Warning (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition.

  - Error (optional): The Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setContentConfig

    public void setContentConfig(PipelineOutputConfig contentConfig)

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the `Grantee` object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

  - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Parameters:
  `contentConfig` - Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the `Grantee` object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

    - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

      - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

#### getContentConfig

    public PipelineOutputConfig getContentConfig()

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the `Grantee` object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

  - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Returns:
  Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the `Grantee` object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

    - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

      - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

#### withContentConfig

    public Pipeline withContentConfig(PipelineOutputConfig contentConfig)

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the `Grantee` object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

  - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Parameters:
  `contentConfig` - Information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions: A list of the users and/or predefined Amazon S3 groups you want to have access to transcoded files and playlists, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the `Grantee` object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to transcoded files and playlists.

    - `Access`: The permission that you want to give to the AWS user that is listed in `Grantee`. Valid values include:

      - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setThumbnailConfig

    public void setThumbnailConfig(PipelineOutputConfig thumbnailConfig)

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the Grantee object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

  - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Parameters:
  `thumbnailConfig` - Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the Grantee object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

        <important>

        A canonical user ID is not the same as an AWS account number.

        </important>

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

    - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

      - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

#### getThumbnailConfig

    public PipelineOutputConfig getThumbnailConfig()

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the Grantee object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

  - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Returns:
  Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the Grantee object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

        <important>

        A canonical user ID is not the same as an AWS account number.

        </important>

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

    - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

      - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

#### withThumbnailConfig

    public Pipeline withThumbnailConfig(PipelineOutputConfig thumbnailConfig)

Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

- `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

  - GranteeType: The type of value that appears in the Grantee object:

    - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - `Email`: The registered email address of an AWS account.

    - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

  - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Parameters:
  `thumbnailConfig` - Information about the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files. Either you specify both `ContentConfig` and `ThumbnailConfig`, or you specify `OutputBucket`.

  - `Bucket`: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - `Permissions`: A list of the users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access that you want them to have.

    - GranteeType: The type of value that appears in the Grantee object:

      - `Canonical`: Either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

        <important>

        A canonical user ID is not the same as an AWS account number.

        </important>

      - `Email`: The registered email address of an AWS account.

      - `Group`: One of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

    - `Grantee`: The AWS user or group that you want to have access to thumbnail files.

    - Access: The permission that you want to give to the AWS user that is listed in Grantee. Valid values include:

      - `READ`: The grantee can read the thumbnails and metadata for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

      - `FULL_CONTROL`: The grantee has READ, READ_ACP, and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `StorageClass`: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public Pipeline clone()

Overrides:
  `clone` in class `Object`